From bc1a43b4c2d851e3496d59fe4d9b73d289f52bd7 Mon Sep 17 00:00:00 2001
From: ashok2022 <ashok@multicorewareinc.com>
Date: Wed, 21 Sep 2022 17:51:35 +0530
Subject: [PATCH] Modify dpb to handle mcstf frames

---
 source/encoder/dpb.cpp | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

diff --git a/source/encoder/dpb.cpp b/source/encoder/dpb.cpp
index d6a43a8df..2fdcd6a92 100644
--- a/source/encoder/dpb.cpp
+++ b/source/encoder/dpb.cpp
@@ -70,10 +70,18 @@ void DPB::recycleUnreferenced()
     {
         Frame *curFrame = iterFrame;
         iterFrame = iterFrame->m_next;
-        if (!curFrame->m_encData->m_bHasReferences && !curFrame->m_countRefEncoders)
+        bool isMCSTFReferenced = false;
+
+        if (curFrame->m_param->bEnableGopBasedTemporalFilter)
+            isMCSTFReferenced = curFrame->m_refPicCnt[1];
+
+        if (!curFrame->m_encData->m_bHasReferences && !curFrame->m_countRefEncoders && !isMCSTFReferenced)
         {
             curFrame->m_bChromaExtended = false;
 
+            if (curFrame->m_param->bEnableGopBasedTemporalFilter)
+                *curFrame->m_isSubSampled = false;
+
             // Reset column counter
             X265_CHECK(curFrame->m_reconRowFlag != NULL, "curFrame->m_reconRowFlag check failure");
             X265_CHECK(curFrame->m_reconColCount != NULL, "curFrame->m_reconColCount check failure");
-- 
2.34.1.windows.1

